SystemOrganization addCategory: #'tODE-AmberDebugger'!

Object subclass: #TOADebugger
	instanceVariableNames: 'exception frames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOADebugger methodsFor: 'private' stamp: 'dkh 10/24/2011 15:11'!
createFrames
    | context frame next |
    frames := OrderedCollection new.
    context := exception signalerContext.
    frame := (TOAFrame new)
        initialContext: context;
        debugger: self;
        yourself.
    [ context isNil ]
        whileFalse: [ 
            frames add: frame.
            context := context sender.
            context
                ifNotNil: [ 
                    next := (TOAFrame new)
                        context: context;
                        debugger: self;
                        yourself.
                    frame next: next.
                    next previous: frame.
                    frame := next ] ]! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
exception
    ^exception! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:39'!
exception: anException
    exception := anException.
    self createFrames! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
frames
    ^frames! !

!TOADebugger methodsFor: 'accessing' stamp: 'dkh 10/25/2011 20:13'!
tODEAmberRendererClass
    false
        ifTrue: [ ^ super tODEAmberRendererClass ].
    ^ TOAmberDebuggerRenderer! !

Object subclass: #TOAFrame
	instanceVariableNames: 'debugger previous next method context receiver pcRange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:54'!
context

	^context! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:09'!
context: aMethodContext

	context := aMethodContext.
	receiver := context receiver.
	method := MethodReference class: context method classBinding value selector: context method selector.
	pcRange := context debuggerMap rangeForPC: context pc contextIsActiveContext: false.! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/25/2011 20:15'!
debugger
	^debugger ! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:40'!
debugger: aTOADebugger

	debugger := aTOADebugger! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/25/2011 20:10'!
exception
    ^ self debugger exception! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:16'!
initialContext: aMethodContext
    context := aMethodContext.
    receiver := context receiver.
    method := MethodReference class: context method classBinding value selector: context method selector.
    pcRange := context debuggerMap rangeForPC: context pc contextIsActiveContext: true! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 12:01'!
method
    ^ method! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/25/2011 20:02'!
next

	^next ! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:49'!
next: aTOAFrame

	next := aTOAFrame! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:12'!
pcRange

	^pcRange! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 15:04'!
previous

	^previous! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 09:50'!
previous: aTOAFrame

	previous := aTOAFrame! !

!TOAFrame methodsFor: 'printing' stamp: 'dkh 10/24/2011 09:53'!
printContext: aContext on: aStream
	| outerContext |
	(outerContext := aContext outerContext)
		ifNil: [aContext  printOn: aStream]
		ifNotNil:
			[
			 aStream nextPutAll: ' [] in '.
			 self printContext: outerContext on: aStream]! !

!TOAFrame methodsFor: 'printing' stamp: 'dkh 10/24/2011 09:54'!
printOn: aStream
	self printContext: self context on: aStream! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/24/2011 12:02'!
receiver
    ^ receiver! !

!TOAFrame methodsFor: 'accessing' stamp: 'dkh 10/25/2011 20:13'!
tODEAmberRendererClass
    ^ TOAmberFrameRenderer! !

TOAmberInspectorRenderer subclass: #TOAmberFrameRenderer
	instanceVariableNames: ''
	classVariableNames: 'TOASourceArea'
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOAmberFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 20:11'!
context
    ^ self object context! !

!TOAmberFrameRenderer methodsFor: 'private' stamp: 'dkh 10/25/2011 19:39'!
convertToLineChar: characterIndex src: src
    | lineCount |
    lineCount := 0.
    src
        lineIndicesDo: [ :start :endNoDelims :end | 
            lineCount := lineCount + 1.
            end >= characterIndex
                ifTrue: [ 
                    ^ {(lineCount - 1).
                    (characterIndex - start + 1)} ] ].
    ^ {(lineCount - 1).
    0}! !

!TOAmberFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 09:25'!
getArgMembers
    | members tempNames |
    members := OrderedCollection new.
    tempNames := self context tempNames.
    1 to: self context numArgs do: [ :index | 
        | each |
        each := tempNames at: index.
        members
            add:
                ((TOInspectorKeylessFieldSpec new)
                    keyLabel: each;
                    value: (self context tempNamed: each)) ].
    ^ members! !

!TOAmberFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 20:44'!
getContextMembers
    | members tempNames |
    members := OrderedCollection new.
    members
        add:
            ((TOInspectorKeylessFieldSpec new)
                keyLabel: '(self)';
                value: self object receiver);
        add:
            ((TOInspectorKeylessFieldSpec new)
                keyLabel: '(thisContext)';
                value: self context).
    tempNames := self context tempNames.
    self context numArgs + 1 to: tempNames size do: [ :index | 
        members
            add:
                ((TOInspectorKeylessFieldSpec new)
                    keyLabel: (tempNames at: index);
                    value: (self context debuggerMap namedTempAt: index in: self context)) ].
    ^ members! !

!TOAmberFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 09:14'!
members
    ^ self getArgMembers, self getContextMembers! !

!TOAmberFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 20:41'!
renderBlockMethod
    "[:frame :object :html :main | ...]"

    ^ [ :frame :obj :html :main | 
    html div
        with: [ 
            | stkFrame rClass mClass |
            (html span)
                style: 'color: red; font-weight: bold; font-size: x-large';
                with: obj state heading.
            stkFrame := obj state frame.
            html br.
            html br.
            html div
                with: [ 
                    | prev next |
                    (prev := stkFrame previous) isNil
                        ifTrue: [ html with: '<<' ]
                        ifFalse: [ 
                            (html a)
                                href: '#';
                                onClick: [ 
                                            frame session push: (prev at: 2).
                                            main renderCenter ];
                                with: '<<' ].
                    html with: ' --- '.
                    (next := stkFrame next) isNil
                        ifTrue: [ html with: '>>' ]
                        ifFalse: [ 
                            (html a)
                                href: '#';
                                onClick: [ 
                                            frame session push: (next at: 2).
                                            main renderCenter ];
                                with: '>>' ] ].
            html br.
            html div
                with: [ 
                    html a
                        with: [ 
                            (html span)
                                style: 'font-size: x-small';
                                with: stkFrame nesting.
                            (html span)
                                style: 'font-size: x-small; font-weight: bold';
                                with: (rClass := stkFrame receiverClass).
                            rClass ~= (mClass := stkFrame methodClass)
                                ifTrue: [ 
                                    (html span)
                                        style: 'font-size: x-small';
                                        with: '(' , mClass , ')' ].
                            html with: '>>'.
                            (html span)
                                style: 'font-size: x-small; font-weight: bold';
                                with: stkFrame selector ] ].
            html br.
            html div
                with: [ 
                    stkFrame sourceArea
                        ifNil: [ 
                            | sourceArea |
                            sourceArea := TOASourceArea new.
                            sourceArea source: stkFrame methodSource.
                            sourceArea renderOn: html.
                            sourceArea setSelection: stkFrame srcFrom end: stkFrame srcTo.
                            sourceArea refresh.
                            stkFrame sourceArea: sourceArea ] ] ].
    html br.
    html div
        with: [ 
            html table
                with: [ 
                    obj state members
                        do: [ :member | 
                            html tr
                                with: [ 
                                    | td |
                                    td := html td.
                                    td style: 'padding: .3px 4px;'.
                                    td
                                        with: [ 
                                            | key url |
                                            key := member key.
                                            (url := key at: 2) isNil
                                                ifTrue: [ html with: (key at: 1) ]
                                                ifFalse: [ 
                                                    (html a)
                                                        href: '#';
                                                        onClick: [ 
                                                                    frame session push: url.
                                                                    main renderCenter ];
                                                        with: (key at: 1) ] ].
                                    td := html td.
                                    td style: 'padding: .3px 4px;'.
                                    td
                                        with: [ 
                                            | value url |
                                            value := member value.
                                            (url := value at: 2) isNil
                                                ifTrue: [ html with: (value at: 1) ]
                                                ifFalse: [ 
                                                    (html a)
                                                        href: '#';
                                                        onClick: [ 
                                                                    frame session push: url.
                                                                    main renderCenter ];
                                                        with: (value at: 1) ] ] ] ] ] ] ]! !

!TOAmberFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 09:28'!
renderContentOn: json
    json
        object: [ 
            json key: 'heading' value: self object exception description.
            self renderFrameOn: json.
            self renderMembersOn: json ]! !

!TOAmberFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 20:03'!
renderFrame: aFrame context: aContext nested: aStream on: json
    | outerContext |
    (outerContext := aContext outerContext)
        ifNil: [ 
            | src previous next |
            src := aFrame method sourceString withUnixLineEndings.
            json key: 'active' value: false.
            json key: 'nesting' value: aStream contents.
            json key: 'receiverClass' value: aContext receiver class name asString.
            json key: 'methodClass' value: aContext method classBinding value name asString.
            json key: 'selector' value: aContext method selector asString.
            json key: 'methodSource' value: src.
            self renderFramePCRange: aFrame on: json.
            json key: 'sourceArea' value: nil.
            (previous := aFrame previous) == nil
                ifTrue: [ json key: 'previous' value: nil ]
                ifFalse: [ 
                    json
                        key: 'previous'
                        value: [ 
                            json
                                array: [ 
                                    json
                                        value: previous printString;
                                        value: [ json callback: [ self frameComponent object: previous ] ] ] ] ].
            (next := aFrame next) == nil
                ifTrue: [ json key: 'next' value: nil ]
                ifFalse: [ 
                    json
                        key: 'next'
                        value: [ 
                            json
                                array: [ 
                                    json
                                        value: next printString;
                                        value: [ json callback: [ self frameComponent object: next ] ] ] ] ] ]
        ifNotNil: [ 
            aStream nextPutAll: ' [] in '.
            self
                renderFrame: aFrame
                context: outerContext
                nested: aStream
                on: json ]! !

!TOAmberFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 19:38'!
renderFrame: aFrame on: json
    self
        renderFrame: aFrame
        context: aFrame context
        nested:(WriteStream on: String new)
        on: json! !

!TOAmberFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 20:12'!
renderFrameOn: json
    json
        key: 'frame'
        value: [ json object: [ self renderFrame: self object on: json ] ]! !

!TOAmberFrameRenderer methodsFor: 'rendering' stamp: 'dkh 10/25/2011 20:16'!
renderFramePCRange: aFrame on: json
    | src first last from to |
    src := aFrame method sourceString withUnixLineEndings.
    from := to := #(0 0).
    first := aFrame pcRange first.
    last := aFrame pcRange last.
    first < last
        ifTrue: [ 
            from := self convertToLineChar: first - 1 src: src.
            to := self convertToLineChar: last src: src ].
    json
        key: 'srcFrom'
        value: [ 
            json
                object: [ 
                    json key: 'line' value: (from at: 1).
                    json key: 'ch' value: (from at: 2) ] ].
    json
        key: 'srcTo'
        value: [ 
            json
                object: [ 
                    json key: 'line' value: (to at: 1).
                    json key: 'ch' value: (to at: 2) ] ]! !

!TOAmberFrameRenderer methodsFor: 'accessing' stamp: 'dkh 10/25/2011 10:00'!
target
    ^ '_blank'! !

!TOAmberErrorHandler methodsFor: '*tode-amberdebugger' stamp: 'dkh 10/25/2011 20:14'!
open: anException
    | renderer |
    [ 
    (anException isKindOf: Halt)
        ifTrue: [ ^ super open: anException ].
    renderer := (TOAmberFrameComponent new)
        object:
                (((TOADebugger new)
                        exception: anException;
                        yourself) frames at: 1);
        target: '_blank';
        yourself.
    self session presenter call: renderer onAnswer: [  ] ] on: Error do: [ :ex | super open: ex ]! !

TOAmberAbstractRenderer subclass: #TOAmberDebuggerRenderer
	instanceVariableNames: ''
	classVariableNames: 'TOASourceArea'
	poolDictionaries: ''
	category: 'tODE-AmberDebugger'!

!TOAmberDebuggerRenderer methodsFor: 'rendering' stamp: 'dkh 10/24/2011 21:12'!
renderBlockMethod
    "[:frame :object :html :main | ...]"

    ^ [ :frame :obj :html :main | 
    (html span)
        style: 'color: red; font-weight: bold; font-size: xx-large';
        with: obj state heading.
    obj state frames
        do: [ :stkFrame | 
            | rClass mClass acc |
            (acc := html div)
                id: 'debuggerFrame' , stkFrame id asString;
                with: [ 
                            html div
                                with: [ 
                                    html a
                                        with: [ 
                                            (html span)
                                                style: 'font-size: x-small';
                                                with: stkFrame nesting.
                                            (html span)
                                                style: 'font-size: x-small; font-weight: bold';
                                                with: (rClass := stkFrame receiverClass).
                                            rClass ~= (mClass := stkFrame methodClass)
                                                ifTrue: [ 
                                                    (html span)
                                                        style: 'font-size: x-small';
                                                        with: '(' , mClass , ')' ].
                                            html with: '>>'.
                                            (html span)
                                                style: 'font-size: x-small; font-weight: bold';
                                                with: stkFrame selector ] ].
                            html div
                                with: [ 
                                    stkFrame sourceArea
                                        ifNil: [ 
                                            | sourceArea |
                                            sourceArea := TOASourceArea new.
                                            sourceArea source: stkFrame methodSource.
                                            sourceArea renderOn: html.
                                            sourceArea
                                                selectionStart: stkFrame srcFrom;
                                                selectionEnd: stkFrame srcTo.
                                            stkFrame sourceArea: sourceArea ] ] ].
            html script
                with:
                    '$( ''#debuggerFrame' , stkFrame id asString , ''').accordion({collapsible: true, fillSpace: false, active: '
                        , stkFrame active asString , '});'.
            acc asJQuery onAccordion: 'accordionchange' do: [ :event :ui :jq | stkFrame sourceArea refresh ] ] ]! !

!TOAmberDebuggerRenderer methodsFor: 'rendering' stamp: 'dkh 10/24/2011 18:36'!
renderContentOn: json
    json
        object: [ 
            json key: 'heading' value: self object exception description.
            json
                key: 'frames'
                value: [ 
                    json
                        array: [ 
                            | frameId |
                            frameId := 0.
                            self object frames
                                do: [ :frame | 
                                    json
                                        value: [ 
                                            json
                                                object: [ 
                                                    json key: 'id' value: frameId.
                                                    frame renderJsonOn: json.
                                                    frameId := frameId + 1 ] ] ] ] ] ]! !
